> This page is for Afterpay.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.cash.app/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.cash.app/_mcp/server.

# Void

POST https://global-api-sandbox.afterpay.com/v2/payments/{orderId}/void
Content-Type: application/json

This endpoint voids the remaining `openToCapture` amount of the payment auth, and refunds the customer.

To make a partial void, specify an amount in the request body.

This operation is idempotent based on the `requestId` (if provided), which allows for the safe retry of multiple requests, guaranteeing the payment operation is only made once.

**Connection Timeouts**

| Timeout | Time (Seconds) |
| ------- | -------------- |
| Open    | 10             |
| Read    | 70             |

Reference: https://developers.cash.app/afterpay/api-reference/reference/payments/void-payment

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Path parameters

- `orderId` (string, required) — The unique ID of the Afterpay Order, returned as the `id` property of the Auth response.

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an object.

- `amount` (Money, optional) — The amount to void. Must be less than or equal to the open to capture amount.
- `requestId` (string, optional) — A unique request ID, required for safe retries. It is recommended that the merchant generate a UUID for each unique void.
- `reason` (string, optional) — Can be passed in void requests to conditionally modify wording of the corresponding customer refund email. This can be set to 1 of 3 values, `cancelledItems`, `amountAdjustment` or `null`

## Response

### 201

If successful, returns an updated copy of the Payment object. - A new Payment Event object is appended to the events array, with a type of "VOIDED". - A new Refund object is prepended to the refunds array. - If the openToCapture amount is reduced to zero as a result of this Void request, the paymentState is updated as follows: - from "AUTH_APPROVED" to "VOIDED", or - from "PARTIALLY_CAPTURED" to "CAPTURED".

- `id` (string, optional) — The unique, permanent, Afterpay generated Order ID.
- `token` (string, optional) — The token obtained from the checkout call
- `status` (enum, optional) — represents the status of the order
  - Allowed values: `APPROVED`, `DECLINED`
- `created` (string, optional) — is the UTC timestamp of when the payment was completed.
- `originalAmount` (Money, optional) — Object containing amount and currency
- `openToCaptureAmount` (Money, optional) — Object containing amount and currency
- `paymentState` (enum, optional) — is the current state for capturing payments
  - Allowed values: `AUTH_APPROVED`, `AUTH_DECLINED`, `PARTIALLY_CAPTURED`, `CAPTURED`, `CAPTURE_DECLINED`, `VOIDED`
- `merchantReference` (string, optional) — is the merchant's order id/reference that the payment corresponds to.
- `refunds` (list of Refund, optional)
- `orderDetails` (Order-Details, optional) — This comprehensive schema is designed to store an entire transaction's detail, covering crucial aspects like consumer information, billing and shipping details, courier particulars, item list, discounts, tax, and shipping amount.
- `events` (list of Payment-Event, optional)

## Errors

### 404 Not Found Error

The `orderId` string provided was empty or did not match a valid order. Error code `not_found`.

- `any`

### 422 Unprocessable Entity Error

The amount in USD has exceeded the open-to-capture amount in USD. Example message: "Void amount USD 999.00 exceeded open to capture amount USD 40.00." Error code `invalid_amount`.

- `any`

## Types

### Money

Object containing amount and currency

- `amount` (string, required) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (enum, required)
  - Allowed values: `AUD`, `NZD`, `USD`, `CAD`, `GBP`

### Refund

To guarantee safe retries, the merchant should offer their refund ID or reference, aligning with their internal records Unique values for the `requestID` and `merchantReference` are required to guarantee safe retries. It is recommended that the merchant generates a UUID for each unique refund request. The `refundMerchantReference` is a unique reference that when provided, will appear in the daily settlement file as "Payment Event Id". In most cases, this would hold the same value as the `merchantReference`.

- `amount` (Money, optional) — Object containing amount and currency
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency. Max length 85 (varchar).
- `refundId` (string, optional) — The unique, permanent, Afterpay-generated Refund ID.
- `refundMerchantReference` (string, optional) — A unique reference for the individual refund event. Max length 128 (varchar).
- `refundedAt` (string, optional)
- `requestId` (string, optional) — Unique ID required for safe retries. Max length 64 (varchar).

### Order-Details

This comprehensive schema is designed to store an entire transaction's detail, covering crucial aspects like consumer information, billing and shipping details, courier particulars, item list, discounts, tax, and shipping amount.

- `consumer` (Consumer, optional) — The consumer data model is used for gathering essential user information. It captures details such as the individual's first name, represented by `givenNames`, and their last name, captured under `surname`. In addition, it stores the user's contact number under `phoneNumber` and their email address under `email`. These fields collectively provide contact and identification details for a user.
- `billing` (Contact, optional) — This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage
- `courier` (Shipping-Courier, optional) — Essential information for tracking a shipment. The `shippedAt` key represents the date and time when the item was shipped. This value follows the [ISO 8601 standard format](https://www.iso.org/iso-8601-date-and-time-format.html) for date and time representations. The `name` field indicates the courier service employed to handle the shipment (e.g. FEDEX, UPS). For orders that are picked up in-store (also known as Buy-Online-Pickup-Instore), please use "INSTORE_PICKUP" as the `name` field value. The `tracking` key represents a unique tracking number provided by the courier service to monitor the shipment's progress. It's a valuable tool for customers and businesses to track and trace their packages. The `priority` field tracks the shipping speed or service level associated with the delivery.
- `items` (list of Item, optional)
- `discounts` (list of Discount, optional)
- `taxAmount` (Money, optional) — Object containing amount and currency
- `shippingAmount` (Money, optional) — Object containing amount and currency

### Payment-Event

Each payment event has a unique ID, creation timestamp, and type (e.g., "AUTH_APPROVED", "AUTH_DECLINED"). For "AUTH_APPROVED" events, an expiration timestamp is provided. The "payment event merchant reference" field, which can be used for payment capture events

- `id` (string, optional)
- `created` (string, optional)
- `expires` (string, optional)
- `type` (enum, optional)
  - Allowed values: `AUTH_APPROVED`, `AUTH_DECLINED`, `CAPTURED`, `CAPTURE_DECLINED`, `VOIDED`, `EXPIRED`
- `amount` (Money, optional) — Object containing amount and currency
- `paymentEventMerchantReference` (string, optional)

### Consumer

The consumer data model is used for gathering essential user information. It captures details such as the individual's first name, represented by `givenNames`, and their last name, captured under `surname`. In addition, it stores the user's contact number under `phoneNumber` and their email address under `email`. These fields collectively provide contact and identification details for a user.

- `email` (string, required)
- `givenNames` (string, optional) — The consumer's first name
- `surname` (string, optional) — The consumer's last name
- `phoneNumber` (string, optional)

### Contact

This data model is used for storing an individual's contact information. Mandatory fields such as **name**, **line1**, **area1**, **region**, **postcode**, and **countryCode** help in capturing vital information about a user's location. The `line2` and `area2` fields provide additional space for extended addresses, while `phoneNumber` can be used to store the user's contact number. The `area1`, `area2` and `region` properties feature localized terminology based on country. Refer to the property descriptions for insights on each country's specific usage

- `name` (string, required)
- `line1` (string, required) — First line of the address
- `area1` (string, required) — - AU: Suburb - NZ: Town or City - UK: Postal Town - US: City - Canada: City
- `region` (string, required) — - AU: State - NZ: Region - UK: County - US: State - CA: Province or Territory
- `postcode` (string, required)
- `countryCode` (enum, required)
  - Allowed values: `AU`, `NZ`, `US`, `CA`, `GB`
- `line2` (string, optional) — Second line of the address
- `area2` (string, optional) — - NZ: suburb - UK: village or local area.
- `phoneNumber` (string, optional) — The phone number, in [E.123](https://en.wikipedia.org/wiki/E.123) format.

### Shipping-Courier

Essential information for tracking a shipment. The `shippedAt` key represents the date and time when the item was shipped. This value follows the [ISO 8601 standard format](https://www.iso.org/iso-8601-date-and-time-format.html) for date and time representations. The `name` field indicates the courier service employed to handle the shipment (e.g. FEDEX, UPS). For orders that are picked up in-store (also known as Buy-Online-Pickup-Instore), please use "INSTORE_PICKUP" as the `name` field value. The `tracking` key represents a unique tracking number provided by the courier service to monitor the shipment's progress. It's a valuable tool for customers and businesses to track and trace their packages. The `priority` field tracks the shipping speed or service level associated with the delivery.

- `shippedAt` (datetime, optional)
- `name` (string, optional)
- `tracking` (string, optional)
- `priority` (enum, optional)
  - Allowed values: `STANDARD`, `EXPRESS`

### Item

This data model is used to store crucial product details. The `price.amount` field represents the unit price of the individual item. The `quantity` field shows the number of units of the item. The `name` field denotes the name of the product, while `sku` holds the Stock Keeping Unit identifier. 100 is the maximum number of item objects in the items array. It is crucial that the `price.amount` represents the unit price of the individual item. **Never** populate the `price.amount` by multiplying the quantity by the unit cost. Always enter the price for a single unit to maintain data accuracy.

- `name` (string, required)
- `quantity` (integer, required)
- `price` (Money, required) — Object containing amount and currency
- `sku` (string, optional)
- `pageUrl` (string, optional)
- `imageUrl` (string, optional)
- `categories` (list of list of string, optional)
- `estimatedShipmentDate` (date, optional)
- `preorder` (boolean, optional, default: false)

### Discount

Discount applied to an order

- `displayName` (string, optional)
- `amount` (Money, optional) — Object containing amount and currency

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": "300000016189",
  "token": "002.6bjbsaowxvfqam2nw4u3xudppheuh4gsuat3n2w3f6t44euzgy",
  "status": "APPROVED",
  "created": "2024-03-11T20:11:42.487Z",
  "originalAmount": {
    "amount": "37.00",
    "currency": "USD"
  },
  "openToCaptureAmount": {
    "amount": "0.00",
    "currency": "USD"
  },
  "paymentState": "CAPTURED",
  "merchantReference": "updated-k6-reference-utaddnpx",
  "refunds": [],
  "orderDetails": {
    "consumer": {
      "email": "test@example.com"
    },
    "billing": {
      "name": "Joe Customer",
      "line1": "1004 New Avenue",
      "area1": "Melbourne",
      "region": "VIC",
      "postcode": "94121",
      "countryCode": "AU",
      "phoneNumber": "2120000000",
      "countrycode": "US"
    },
    "courier": {
      "shippedAt": "2024-01-01T08:00:00Z",
      "name": "FedEx",
      "tracking": "000 000 000 000",
      "priority": "STANDARD"
    },
    "items": [
      {
        "name": "Blue Carabiner",
        "quantity": 1,
        "price": {
          "amount": "40.00",
          "currency": "USD"
        },
        "sku": "12341234"
      }
    ],
    "categories": {
      "categories": null,
      "name": "Jeans",
      "price": {
        "amount": "20.00",
        "currency": "USD"
      },
      "quantity": 1,
      "sku": "123412345"
    },
    "shipping": {
      "countrycode": "US",
      "line1": "1004 New Avenue",
      "name": "Joe Customer",
      "phoneNumber": "2120000000",
      "postcode": "94121"
    }
  },
  "events": [
    {
      "id": "2dYbLXpOtEPQbg1DT7x9D8R4oCY",
      "created": "2024-03-11T20:11:43.897Z",
      "type": "CAPTURED",
      "amount": {
        "amount": "37.00",
        "currency": "USD"
      },
      "paymentEventMerchantReference": "k6-gsrdqspusf"
    }
  ],
  "discounts": [],
  "shippingAmount": {
    "amount": "10.00",
    "currency": "USD"
  },
  "taxAmount": {
    "amount": "0.00",
    "currency": "USD"
  }
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/orderId/void"

payload = {}
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/void';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/orderId/void"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/orderId/void")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/payments/orderId/void")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/payments/orderId/void', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/orderId/void");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/orderId/void")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```